(function ($, Drupal) {
  Drupal.behaviors.siteSearch360Suggestions = {
    attach: function (context, settings) {

      var minChars = 3; // TODO: make configurable

      // TODO: make the selector user configurable in admin
      $('#search-form input[type="search"], #search-block-form input[type="search"]', context).once('ss360Suggestions').each(function () {
        var awesomeInstance = new Awesomplete(this, {
          minChars: minChars,
          filter: function () {
            return true;
          }
        });

        $(this).on('input', $.debounce(200, function (e) {
          if (this.value.length < minChars) {
            return false;
          }

          $.ajax({
            url: '/api/search/suggests/' + this.value,
            success: function (data) {
              awesomeInstance._list = data;
              awesomeInstance.evaluate();
            }
          });
        }));

        $(this).on('awesomplete-selectcomplete', function (e) {

          // prevent the field to be filled with the url
          this.value = '';

          window.location = e.originalEvent.text.value;
        });

      });
    }
  };
})(jQuery, Drupal);
